use strict;

use LWP::Parallel::UserAgent;
use HTTP::Request;

##no critic qw( ProhibitMagicNumbers )

my $pua = LWP::Parallel::UserAgent->new();
$pua->in_order(0);  # handle requests in order of registration
$pua->redirect(0);  # follow redirects
$pua->timeout(300); # in seconds
# max number of requests to process simultaneously:
$pua->max_req(18);

my @Responses;
my $Url = 'https://api.github.com/repos/ePages-de/Cartridges/pulls';
my @itemList = qw(6014 6013 6012 6010 6003 5995 5986 5985 5981 5978);

foreach my $item (@itemList) {
    my $req = HTTP::Request->new(GET => "$Url/$item");
    $req->header('Authorization',"token $ENV{GITHUB_AUTH_TOKEN}");
    $req->header('User-Agent',' LWP::Parallel::UserAgent/v2.62');
    $pua->register($req);
}

my $performed = $pua->wait(300);

foreach my $response (keys %$performed) {
    push @Responses, {
        uri => $performed->{$response}->response->request->uri->as_string,
        code => $performed->{$response}->response->code,
        message => $performed->{$response}->response->message,
        content => $performed->{$response}->response->content,
    }
}

foreach my $response (@Responses) {
    foreach my $key (qw(uri code message content)) {
        print "$key: $response->{$key}\n";
    }
}
