use strict;

use Net::Curl::Parallel;
use HTTP::Request;

##no critic qw( ProhibitMagicNumbers )

my $pua = Net::Curl::Parallel->new(
  agent           => 'Net::Curl::Parallel/v0.1',
  slots           => 18,
  max_redirects   => 0,
  connect_timeout => 300 * 1000,
  request_timeout => 300 * 1000,
);

my @Responses;
my $Url = 'https://api.github.com/repos/ePages-de/Cartridges/pulls';
my @itemList = qw(6014 6013 6012 6010 6003 5995 5986 5985 5981 5978);

foreach my $item (@itemList) {
    my $req = HTTP::Request->new(GET => "$Url/$item");
    push @Responses, { uri => "$Url/$item" };
    $req->header('Authorization',"token $ENV{GITHUB_AUTH_TOKEN}");
    $pua->try($req);
}

my @performed = $pua->perform;

my $count = 0;
foreach my $response (@performed) {
    ${Responses[$count]}{code} = $response->status();
    ${Responses[$count]}{message} = $response->error();
    ${Responses[$count]}{content} = $response->content();
    $count++;
}

foreach my $response (@Responses) {
    foreach my $key (qw(uri code message content)) {
        print "$key: $response->{$key}\n";
    }
}
