#========================================================================================
# package      DE_EPAGES::MolliePayments::API::Attributes::PaymentMethodMolliePayments
# state        public
# base         DE_EPAGES::Object::API::BaseAttribute
# description  Attribute interface for PaymentMethodMolliePayments
#========================================================================================
package DE_EPAGES::MolliePayments::API::Attributes::PaymentMethodMolliePayments;
use base qw ( DE_EPAGES::Object::API::BaseAttribute );

use strict;


#========================================================================================
# function     getAttributes
# state        public
#----------------------------------------------------------------------------------------
# syntax       getAttributes( $PaymentMethodMolliePayments, $aName );
#----------------------------------------------------------------------------------------
# description  Returns attribute values of an object.
#               Used by <function DE_EPAGES::Object::Object::Object::get>
#----------------------------------------------------------------------------------------
# input        $PaymentMethodMolliePayments | object | DE_EPAGES::MolliePayments::API::Object::PaymentMethodMolliePayments
# input        $aNames | list of attribute names | ref.array
# return       $hValues | attribute name => value hash | ref.hash
#========================================================================================
sub getAttributes {
    my $self = shift;
    my ($PaymentMethodMolliePayments, $aName) = @_;
    my $hInfo = {};
    foreach my $Name (@{$aName}) {
        if($Name eq 'AreMandatoryFieldsSet') {
            $hInfo->{$Name} = $PaymentMethodMolliePayments->areMandatoryFieldsSet();
        }
    }
    return $hInfo;
}
1;