sequenceDiagram
autonumber
participant shopper as Shopper
participant storefront as Storefront <br/> (Browser)
participant epages6 as ePages6 <br/> (Cartridges)
participant saferpay as Saferpay <br/> (JSON API)
participant saferpayHpp as Saferpay <br/> Hosted Payment Page

Note over shopper, epages6:Shopper is on the checkout Payment Selection Page
shopper->>storefront: Chooses a Saferpay Payment method
shopper->>storefront: Clicks "Continue"

Note over shopper, epages6:Shopper is on the Buy confirmation page <br/> ChangeAction: SaveMultiCheckoutConfirmation, ViewAction: ViewMultiPaymentSaferpay2)
shopper->>storefront: Clicks "Buy" <br> 

Note over shopper, epages6:Shopper is on Payment Redirect Page <br/> (ViewMultiPaymentSaferpay2)
storefront->>epages6: Build Saferpay initialization request<br> UI::BasketOrder::ViewPaymentSaferpay2 <br/>(build NotifyUrl: ChangeAction=PaymentCallbackSaferpay2, Return.Success: ChangeAction=PaymentBacklinkSaferpay2 )
epages6->>saferpay: Initialize Saferpay transaction (API::SaferpayService::InitializePaymentPage)<br/> POST "Payment/v1/PaymentPage/Initialize" {Payment,ReturnUrls,Notification,RequestURL}
saferpay->>epages6: Return Saferpay transaction Token and RedirectUrl

Note over epages6: Save Token
epages6->>epages6: Save transaction Token into TransID2
epages6->>storefront: Redirect to checkout url
storefront->>saferpayHpp: Redirect browser to RedirectUrl - Saferpay Hosted payment page


Note over shopper, saferpay:Shopper is on Saferpay Hosted Payment Page 
shopper->>saferpayHpp: Shopper fills the payment details and clicks "Buy"  


alt Saferpay server callback (Status paid)

saferpay->>epages6: Saferpay calls payment webhook <br> UI::Shop::PaymentCallbackSaferpay2

else Saferpay redirect url to success or error page

saferpay->>epages6: Redirect to ePages <br> UI::Shop::PaymentBacklinkSaferpay2
end

epages6->>storefront: Redirect to Order Confirmation Page
Note over shopper, epages6: Shopper will see a successful order confirmation page