#========================================================================================
# package      DE_EPAGES::ShopMigrationProvider::DAL::SQL::ShopRef
# state        private
# description  SQL database interface for tables:
#               <ul>
#                   <li>shopref
#               </ul>
#========================================================================================
package DE_EPAGES::ShopMigrationProvider::DAL::SQL::ShopRef;

use strict;

#=================================================================================================================
# function     GetPKeyShopRefsByStoreIDandStoreObjectID
#-----------------------------------------------------------------------------------------------------------------
# syntax       $aResult = $Package->GetPKeyShopRefsByStoreIDandStoreObjectID($dbh, $StoreID, $StoreObjectID);
#-----------------------------------------------------------------------------------------------------------------
# description  Get list of ShopRefIDs by shopref alias.
#----------------------------------------------------------------------------------------
# input        $dbh | database handle | object
# input        $StoreID | store id | integer
# input        $StoreObjectID | storeobjectid | integer
# return       $aResult | list of shopref ids | array
#========================================================================================
sub GetPKeyShopRefsByStoreIDandStoreObjectID {
    my $self    = shift;
    my ($dbi, $StoreID, $StoreObjectID) = @_;

    my $sql = 'select shoprefid from shopref s where s.storeid = ? and s.storeobjectid = ?';
    my $dbResult = $dbi->execute( $sql, [$StoreID, $StoreObjectID], ['Integer'] );
    return [ map { $_->[0] } @$dbResult ];
}

1;
