#========================================================================================
# package      DE_EPAGES::ShopMigrationProvider::DAL::ShopRef
# state        private
# description  database interface for tables:
#               <ul>
#                   <li>shopref
#               </ul>
#========================================================================================
package DE_EPAGES::ShopMigrationProvider::DAL::ShopRef;
use base qw (Exporter);

use strict;
our @EXPORT = qw (
    DAL_GetPKeyShopRefsByStoreIDandStoreObjectID
);

use DE_EPAGES::Core::API::Log qw (GetLog);
use DE_EPAGES::Database::API::Connection qw (GetCurrentDBHandle);

sub _CallDriver {
    my ( $FunctionName, @Parameter ) = @_;
    my $dbi     = GetCurrentDBHandle();
    my $Package = 'DE_EPAGES::ShopMigrationProvider::DAL::SQL::ShopRef';
    eval "use $Package;";  ## no critic ( BuiltinFunctions::ProhibitStringyEval )
    die $@ if $@;
    GetLog->debug("call $Package->$FunctionName()");
    return $Package->$FunctionName( $dbi, @Parameter );
}

#========================================================================================
# function     DAL_GetPKeyShopRefsByStoreIDandStoreObjectID
#----------------------------------------------------------------------------------------
# syntax       $aResult = DAL_GetPKeyShopRefsByStoreIDandStoreObjectID($StoreID,$StoreObjectID);
#----------------------------------------------------------------------------------------
# description  get list of ShopRefIDs by storeid, storeobjectid
#----------------------------------------------------------------------------------------
# input        $StoreID | store id | integer
# input        $StoreObjectID | storeobjectid | integer
# return       $aResult | list of shopref ids | array
#========================================================================================
sub DAL_GetPKeyShopRefsByStoreIDandStoreObjectID ($$) {
    my ($StoreID,$StoreObjectID) = @_;

    return _CallDriver( 'GetPKeyShopRefsByStoreIDandStoreObjectID', $StoreID,$StoreObjectID );
}

1;
