sequenceDiagram
autonumber

participant Shopper as Shopper
participant Storefront as Storefront <br/> (Browser)
participant epages6 as epages6 <br/> (Cartridges)
participant epagesj as ePagesJ
participant Spreedly as Spreedly

Note over Shopper, Storefront:Checkout: Payment selection page

Shopper->>Storefront: Shopper selects a Spreedly payment method and clicks "Next" button

Storefront-->>Spreedly: Configure and Initiate spreedly library <br> express.js / SpreedlyExpress.init

Spreedly-->>Storefront: Show Spreedly credit card Widget

Shopper->>Spreedly: Shopper inserts credit card data and clicks Confirm button

Spreedly-->>Storefront: Stores credit card data and returns payment method token <br> express.js / SpreedlyExpress.onPaymentMethod

Storefront->>epages6: Submits Payment selection Form with token

epages6->>epages6: Stores payment method token <br> Hooks::OrderProcess::AfterSaveMultiCheckoutPayment

epages6-->>Storefront:Shows Order confirmation page

Note over Shopper, Storefront: Checkout: Order Confirmation page

Shopper->>Storefront: Shopper clicks "Buy" button <br> checkoutconfirmation.js / onBuyButtonClick

Storefront->>epages6:Send Purchase request <br> UI::JSON::MakePurchase

epages6->>epagesj:Send Purchase request <br> POST "payments/spreedly/purchase?shopId={shopId}&gatewayName={gatewayName}"

epagesj->>Spreedly:Send Purchase request <br> POST "https://core.spreedly.com/v1/gateways/{token}/purchase.json"

Spreedly-->>epagesj: Return Transaction response <br> proxy.SpreedlyProxyImpl.getSpreedlyTransactionResult

epagesj-->>epages6:Return Transaction response <br> UI::JSON::MakePurchase

alt credit cards with 3DS2

    epages6-->>Storefront:Return Transaction response with Status "pending" <br> checkoutconfirmation.js / onSuccessfulPurchaseResponse

    Storefront->>Spreedly: Initiate javascript lifecycle <br> checkoutlifecycle.js

    Spreedly-->>Storefront: Show MFA challenge

    Shopper->>Spreedly: Shopper completes the MFA challenge

    Spreedly-->>Storefront: Return Status "trigger-completion" <br> checkoutlifecycle.js / on3dsStatusUpdate

     Storefront->>epages6: Complete transaction <br> UI::JSON::CompleteTransaction

     epages6->>epagesj: Complete transaction <br> POST "payments/spreedly/complete"

     epagesj->>Spreedly:Send Complete transaction request <br> POST "https://core.spreedly.com/v1/transactions/{token}/complete.json"

    Spreedly-->>epagesj: Return Transaction response <br> proxy.SpreedlyProxyImpl.getSpreedlyTransactionResult

    epagesj-->>epages6: Return Transaction response <br> UI::JSON::CompleteTransaction

    epages6-->>Storefront: Return Transaction response <br> checkoutlifecycle.js / onSuccessTriggerCompletion

else credit cards with 3DS1

    epages6-->>Storefront:Return Transaction response with Status "pending" <br> checkoutconfirmation.js / onSuccessfulPurchaseResponse

    Storefront->>Spreedly: Redirect to Transaction.checkout_url

    Shopper->>Spreedly: Shopper completes transaction

    Spreedly-->>Storefront: Redirect to ViewMultiCheckoutConfirmation with transaction_token parameter <br> checkoutconfirmation.js / handleSpreedlyCallback

else credit cards without 3DS

    epages6-->>Storefront:Return Transaction response with Status "success" <br> checkoutconfirmation.js / onSuccessfulPurchaseResponse

end

Storefront-->>epages6: Submit Order confirmation Form

epages6-->>epages6: Confirm Successful Transaction <br> Hooks::OrderProcess::OnSaveMultiCheckoutConfirmation

epages6->>epagesj: Get transaction <br> GET "payments/spreedly/show?shopId={shopId}&gatewayName={gatewayName}&transactionToken={transactionToken}"

epagesj->>Spreedly: Get transaction <br> GET "https://core.spreedly.com/v1/transactions/{token}.json"

Spreedly-->>epagesj: Return Transaction response <br> proxy.SpreedlyProxyImpl.getSpreedlyTransactionResult

epagesj-->>epages6: Return Transaction response <br> UI::BasketOrder::ConfirmSuccessfulTransaction

epages6->>epages6: Creates Order via OrderProcess

epages6-->>Storefront: View Order

Note over Shopper, Storefront: Checkout: Successful Order page
