sequenceDiagram
autonumber

participant Merchant as Merchant
participant MBO as Merchant Backoffice <br/> (Browser)
participant epages6 as ePages6 <br/> (Cartridges)
participant epagesj as ePagesJ
participant Spreedly as Spreedly

Note over Merchant, epages6:Merchant is on MBO Payments: Spreedly Payment settings page <br> UI::PaymentMethodSpreedly::ViewSettings

epages6->>epages6: buildViewSettings[Gateway]<br>UI::PaymentMethodSpreedly[Gateway]::ViewSettingsSpreedly[Gateway]

alt Onboarding via Oauth (Stripe, StripePaymentIntents)
    Merchant->>MBO: Merchant clicks Onboarding link

    MBO->>Spreedly: Merchant is redirected to Payment Gateway (Stripe, StripePaymentIntents)

    Merchant->>Spreedly: Merchant logs in at Payment Gateway (Stripe, StripePaymentIntents) and authorizes

    Spreedly-->>epages6: Returns authorizationCode <br> UI::Stripe::BacklinkStripeOnboarding

else Onboarding inserting credentials (Authorize, AuthorizeEvo, MercadoPago, PayULatam, Payeezy)

    Merchant->>MBO: Merchant inserts credentials and clicks save

    MBO->>epages6: Save Settings <br> UI::PaymentMethodSpreedly::SaveSettings

end

epages6-->>epages6: ViewSettings gets called with credentials saved <br> UI::PaymentMethodSpreedly[Gateway]::ViewSettingsSpreedly[Gateway]

epages6->>epagesj: Insert Spreedly Gateway <br> PUT "payments/spreedly/gateways"

epagesj->>Spreedly: Insert Spreedly Gateway <br> POST "https://core.spreedly.com/v1/gateways.json"

Spreedly-->>epagesj: Returns token

epagesj->>epagesj: Save Gateway token <br> gateway.GatewayServiceImpl.saveGateway

epagesj-->>epages6: Returns 200 <br> UI::PaymentMethodSpreedly::SaveSettings

epages6-->>MBO: Renders ViewSettings
